import React, {
  createContext,
  useContext,
  useState,
  useEffect,
  useLayoutEffect,
  FC,
} from "react";
import { AS } from "../storageControl";
import { getStationList } from "../lib/getStationList";

type initialStateType = {
  originalStationList: any[];
  setOriginalStationList: React.Dispatch<React.SetStateAction<any[]>>;
};
const initialState = {
  originalStationList: [],
  setOriginalStationList: () => {},
};

const StationListContext = createContext<initialStateType>(initialState);
type Props = {
  children: React.ReactNode;
};
export const useStationList = () => {
  return useContext(StationListContext);
};

export const StationListProvider: FC<Props> = ({ children }) => {
  const [originalStationList, setOriginalStationList] = useState<any[]>();
  useEffect(() => {
    getStationList().then(setOriginalStationList);
  }, []);

  return (
    <StationListContext.Provider
      value={{ originalStationList, setOriginalStationList }}
    >
      {children}
    </StationListContext.Provider>
  );
};
